import express, { Request, Response } from 'express';
import { Account, Category, Transaction } from "../models";
import moment from "moment";
import { convertDateArray } from '../helper/dateConversion';

export class CategoryRouter {
    static routes() {
        let router = express.Router();
        router.use((req, res, next) => {
            console.log("TEST")
            next()
        })
        router.post('/addCategory',async(req,res)=>{
            let name = req.body.categoryName;
            let description = req.body.categoryDescription;
            await Category.create({
                Name:name,
                Description:description
            })
            res.redirect("/categories");
            //res.render('categories/listCategories', { title: 'Categories', categories });

        })
        router.get('/addCategory',async(req,res)=>{
            try {
                res.render('categories/formCategory', { title: 'Add Categories' });
            } catch (err) {
                console.error(err);
                res.status(500).send('Internal Server Error');
            }
        })
        router.post('/modifyCategory/:id',async(req,res)=>{
            let name = req.body.categoryName;
            let description = req.body.categoryDescription;
            await Category.update({
                Name:name,
                Description:description
            },{
                where:{
                    CategoryID:req.params.id
                }
            })
            res.redirect("/categories");
            //res.render('categories/listCategories', { title: 'Categories', categories });

        })
        router.get('/modifyCategory/:id',async(req,res)=>{
            try {
                let categoryObj = await Category.findOne({where:{
                    CategoryID: req.params.id
                }})
                res.render('categories/modifyCategory', { title: 'Add Categories',categoryObj });
            } catch (err) {
                console.error(err);
                res.status(500).send('Internal Server Error');
            }
        })
        router.all('/', async (req, res) => {
            try {
                const categories = await Category.findAll({});
                const accounts = await Account.findAll({});
                res.render('categories/listCategories', { title: 'Categories', categories });
            } catch (err) {
                console.error(err);
                res.status(500).send('Internal Server Error');
            }
        })

        return router;
    }
}