import { Request, NextFunction, Response } from "express";
import moment from "moment";
import { Category, Transaction, Account } from "../../models";

const POST = async (req: Request, res: Response, next: NextFunction, data = {}) => {
    try {
        let date = moment(req.body.date).set({
            hour: req.body.time.split(":")[0],
            minute: req.body.time.split(":")[1]
        })
        console.log(date.toDate())
        await Transaction.create({
            Amount: req.body.amount,
            Date: date.toDate(),
            Type: req.body.type,
            //@ts-ignore
            UserID: 1, // Associate the transaction with the user
            //@ts-ignore
            CategoryID: req.body.category,
            AccountID: req.body.account
        })
    } catch (e) {
        console.log(e)
    }
    res.redirect("/transactions");
}

const GET = async (req: Request, res: Response, next: NextFunction, data = {}) => {
    try {
        const transactions = await Transaction.findAll({
            include: Account
        });
        const categories = await Category.findAll({order:[["Name","ASC"]]});
        const accounts = await Account.findAll({order:[["Name","ASC"]]});
        //console.log(transactions)
        res.render('transactions/formTransaction', { title: 'Transactions', transactions, categories, accounts });
    } catch (err) {
        console.error(err);
        res.status(500).send('Internal Server Error');
    }
}

export default { POST, GET };