import { Request, NextFunction, Response } from "express";
import moment from "moment";
import { Op } from "sequelize";

import { Category, Transaction, Account } from "../../models";
import { convertDateArray } from "../../helper/dateConversion";
import { getFirstLastDayOfMonth } from "../../helper";

const GET = async (req: Request, res: Response, next: NextFunction, data:any = {date:new Date(),where:{}}) => {
    try {
        const transactions:any = await Transaction.findOne({
            include: [Account,Category],
            where:{
                TransactionID: req.params.id
            }
        });
        const categories = await Category.findAll({});
        const accounts = await Account.findAll({});

        const arr = convertDateArray(transactions);
        
        res.render('transactions/modifyTransaction', { title: 'Transactions', transaction: transaction, categories, accounts, cssClass:"fullList" });
    } catch (err) {
        console.error(err);
        res.status(500).send('Internal Server Error');
    }
}

export default { GET };